package com.yanzuoguang.mq.service;

import com.yanzuoguang.mq.vo.MessageVo;
import com.yanzuoguang.mq.vo.QueueVo;
import com.yanzuoguang.mq.vo.req.QueueQueryReqVo;
import com.yanzuoguang.util.vo.PageSizeData;
import com.yanzuoguang.util.vo.ResponseResult;

/**
 * 消息队列服务
 */
public interface MqService {
    /**
     * 保存演示DEMO
     *
     * @param req
     */
    ResponseResult<String> createQueue(QueueVo req);

    /**
     * 查询队列
     *
     * @param req 请求数据
     * @return 查询结果
     */
    ResponseResult<PageSizeData<QueueVo>> queryQueue(QueueQueryReqVo req);

    /**
     * 查询队列
     *
     * @return 查询结果
     */
    ResponseResult<String> queryInit();

    /**
     * 发送消息
     *
     * @param req 需要发送的消息
     * @return 消息编号，但是没有任何意义，发送成功会更改
     */
    ResponseResult<String> message(MessageVo req);

    /**
     * 发送错误消息
     *
     * @param req
     * @return
     */
    ResponseResult<String> message_error(MessageVo req);
}
